upstream_keras_io_urls_map <-
list(keras.Model = "https://keras.io/api/models/model#model-class", 
    keras.Model.summary = "https://keras.io/api/models/model#summary-method", 
    keras.Model.get_layer = "https://keras.io/api/models/model#getlayer-method", 
    keras.Sequential = "https://keras.io/api/models/sequential#sequential-class", 
    keras.Sequential.add = "https://keras.io/api/models/sequential#add-method", 
    keras.Sequential.pop = "https://keras.io/api/models/sequential#pop-method", 
    keras.Model.compile = "https://keras.io/api/models/model_training_apis#compile-method", 
    keras.Model.fit = "https://keras.io/api/models/model_training_apis#fit-method", 
    keras.Model.evaluate = "https://keras.io/api/models/model_training_apis#evaluate-method", 
    keras.Model.predict = "https://keras.io/api/models/model_training_apis#predict-method", 
    keras.Model.train_on_batch = "https://keras.io/api/models/model_training_apis#trainonbatch-method", 
    keras.Model.test_on_batch = "https://keras.io/api/models/model_training_apis#testonbatch-method", 
    keras.Model.predict_on_batch = "https://keras.io/api/models/model_training_apis#predictonbatch-method", 
    keras.Model.run_eagerly = "https://keras.io/api/models/model_training_apis#runeagerly-property", 
    keras.Model.save = "https://keras.io/api/models/model_saving_apis/model_saving_and_loading#save-method", 
    keras.Model.get_weights = "https://keras.io/api/models/model_saving_apis/weights_saving_and_loading#getweights-method", 
    keras.Model.set_weights = "https://keras.io/api/models/model_saving_apis/weights_saving_and_loading#setweights-method", 
    keras.Model.save_weights = "https://keras.io/api/models/model_saving_apis/weights_saving_and_loading#saveweights-method", 
    keras.Model.load_weights = "https://keras.io/api/models/model_saving_apis/weights_saving_and_loading#loadweights-method", 
    keras.Model.get_config = "https://keras.io/api/models/model_saving_apis/model_config_serialization#getconfig-method", 
    keras.Model.from_config = "https://keras.io/api/models/model_saving_apis/model_config_serialization#fromconfig-method", 
    keras.models.clone_model = "https://keras.io/api/models/model_saving_apis/model_config_serialization#clonemodel-function", 
    keras.export.ExportArchive = "https://keras.io/api/models/model_saving_apis/export#exportarchive-class", 
    keras.utils.serialize_keras_object = "https://keras.io/api/models/model_saving_apis/serialization_utils#serializekerasobject-function", 
    keras.utils.deserialize_keras_object = "https://keras.io/api/models/model_saving_apis/serialization_utils#deserializekerasobject-function", 
    keras.layers.Layer = "https://keras.io/api/layers/base_layer#layer-class", 
    keras.layers.Layer.weights = "https://keras.io/api/layers/base_layer#weights-property", 
    keras.layers.Layer.trainable_weights = "https://keras.io/api/layers/base_layer#trainableweights-property", 
    keras.layers.Layer.non_trainable_weights = "https://keras.io/api/layers/base_layer#nontrainableweights-property", 
    keras.layers.Layer.add_weight = "https://keras.io/api/layers/base_layer#addweight-method", 
    keras.layers.Layer.trainable = "https://keras.io/api/layers/base_layer#trainable-property", 
    keras.layers.Layer.get_weights = "https://keras.io/api/layers/base_layer#getweights-method", 
    keras.layers.Layer.set_weights = "https://keras.io/api/layers/base_layer#setweights-method", 
    keras.Model.get_config = "https://keras.io/api/layers/base_layer#getconfig-method", 
    keras.layers.Layer.add_loss = "https://keras.io/api/layers/base_layer#addloss-method", 
    keras.layers.Layer.losses = "https://keras.io/api/layers/base_layer#losses-property", 
    keras.activations.relu = "https://keras.io/api/layers/activations#relu-function", 
    keras.activations.sigmoid = "https://keras.io/api/layers/activations#sigmoid-function", 
    keras.activations.softmax = "https://keras.io/api/layers/activations#softmax-function", 
    keras.activations.softplus = "https://keras.io/api/layers/activations#softplus-function", 
    keras.activations.softsign = "https://keras.io/api/layers/activations#softsign-function", 
    keras.activations.tanh = "https://keras.io/api/layers/activations#tanh-function", 
    keras.activations.selu = "https://keras.io/api/layers/activations#selu-function", 
    keras.activations.elu = "https://keras.io/api/layers/activations#elu-function", 
    keras.activations.exponential = "https://keras.io/api/layers/activations#exponential-function", 
    keras.initializers.RandomNormal = "https://keras.io/api/layers/initializers#randomnormal-class", 
    keras.initializers.RandomUniform = "https://keras.io/api/layers/initializers#randomuniform-class", 
    keras.initializers.TruncatedNormal = "https://keras.io/api/layers/initializers#truncatednormal-class", 
    keras.initializers.Zeros = "https://keras.io/api/layers/initializers#zeros-class", 
    keras.initializers.Ones = "https://keras.io/api/layers/initializers#ones-class", 
    keras.initializers.GlorotNormal = "https://keras.io/api/layers/initializers#glorotnormal-class", 
    keras.initializers.GlorotUniform = "https://keras.io/api/layers/initializers#glorotuniform-class", 
    keras.initializers.HeNormal = "https://keras.io/api/layers/initializers#henormal-class", 
    keras.initializers.HeUniform = "https://keras.io/api/layers/initializers#heuniform-class", 
    keras.initializers.Identity = "https://keras.io/api/layers/initializers#identity-class", 
    keras.initializers.Orthogonal = "https://keras.io/api/layers/initializers#orthogonal-class", 
    keras.initializers.Constant = "https://keras.io/api/layers/initializers#constant-class", 
    keras.initializers.VarianceScaling = "https://keras.io/api/layers/initializers#variancescaling-class", 
    keras.regularizers.L1 = "https://keras.io/api/layers/regularizers#l1-class", 
    keras.regularizers.L2 = "https://keras.io/api/layers/regularizers#l2-class", 
    keras.regularizers.L1L2 = "https://keras.io/api/layers/regularizers#l1l2-class", 
    keras.regularizers.OrthogonalRegularizer = "https://keras.io/api/layers/regularizers#orthogonalregularizer-class", 
    keras.constraints.MaxNorm = "https://keras.io/api/layers/constraints#maxnorm-class", 
    keras.constraints.MinMaxNorm = "https://keras.io/api/layers/constraints#minmaxnorm-class", 
    keras.constraints.NonNeg = "https://keras.io/api/layers/constraints#nonneg-class", 
    keras.constraints.UnitNorm = "https://keras.io/api/layers/constraints#unitnorm-class", 
    keras.Input = "https://keras.io/api/layers/core_layers/input#input-function", 
    keras.layers.Dense = "https://keras.io/api/layers/core_layers/dense#dense-class", 
    keras.layers.Activation = "https://keras.io/api/layers/core_layers/activation#activation-class", 
    keras.layers.Embedding = "https://keras.io/api/layers/core_layers/embedding#embedding-class", 
    keras.layers.Masking = "https://keras.io/api/layers/core_layers/masking#masking-class", 
    keras.layers.Lambda = "https://keras.io/api/layers/core_layers/lambda#lambda-class", 
    keras.layers.Conv1D = "https://keras.io/api/layers/convolution_layers/convolution1d#conv1d-class", 
    keras.layers.Conv2D = "https://keras.io/api/layers/convolution_layers/convolution2d#conv2d-class", 
    keras.layers.Conv3D = "https://keras.io/api/layers/convolution_layers/convolution3d#conv3d-class", 
    keras.layers.SeparableConv1D = "https://keras.io/api/layers/convolution_layers/separable_convolution1d#separableconv1d-class", 
    keras.layers.SeparableConv2D = "https://keras.io/api/layers/convolution_layers/separable_convolution2d#separableconv2d-class", 
    keras.layers.DepthwiseConv2D = "https://keras.io/api/layers/convolution_layers/depthwise_convolution2d#depthwiseconv2d-class", 
    keras.layers.Conv1DTranspose = "https://keras.io/api/layers/convolution_layers/convolution1d_transpose#conv1dtranspose-class", 
    keras.layers.Conv2DTranspose = "https://keras.io/api/layers/convolution_layers/convolution2d_transpose#conv2dtranspose-class", 
    keras.layers.Conv3DTranspose = "https://keras.io/api/layers/convolution_layers/convolution3d_transpose#conv3dtranspose-class", 
    keras.layers.MaxPooling1D = "https://keras.io/api/layers/pooling_layers/max_pooling1d#maxpooling1d-class", 
    keras.layers.MaxPooling2D = "https://keras.io/api/layers/pooling_layers/max_pooling2d#maxpooling2d-class", 
    keras.layers.MaxPooling3D = "https://keras.io/api/layers/pooling_layers/max_pooling3d#maxpooling3d-class", 
    keras.layers.AveragePooling1D = "https://keras.io/api/layers/pooling_layers/average_pooling1d#averagepooling1d-class", 
    keras.layers.AveragePooling2D = "https://keras.io/api/layers/pooling_layers/average_pooling2d#averagepooling2d-class", 
    keras.layers.AveragePooling3D = "https://keras.io/api/layers/pooling_layers/average_pooling3d#averagepooling3d-class", 
    keras.layers.GlobalMaxPooling1D = "https://keras.io/api/layers/pooling_layers/global_max_pooling1d#globalmaxpooling1d-class", 
    keras.layers.GlobalMaxPooling2D = "https://keras.io/api/layers/pooling_layers/global_max_pooling2d#globalmaxpooling2d-class", 
    keras.layers.GlobalMaxPooling3D = "https://keras.io/api/layers/pooling_layers/global_max_pooling3d#globalmaxpooling3d-class", 
    keras.layers.GlobalAveragePooling1D = "https://keras.io/api/layers/pooling_layers/global_average_pooling1d#globalaveragepooling1d-class", 
    keras.layers.GlobalAveragePooling2D = "https://keras.io/api/layers/pooling_layers/global_average_pooling2d#globalaveragepooling2d-class", 
    keras.layers.GlobalAveragePooling3D = "https://keras.io/api/layers/pooling_layers/global_average_pooling3d#globalaveragepooling3d-class", 
    keras.layers.LSTM = "https://keras.io/api/layers/recurrent_layers/lstm#lstm-class", 
    keras.layers.GRU = "https://keras.io/api/layers/recurrent_layers/gru#gru-class", 
    keras.layers.SimpleRNN = "https://keras.io/api/layers/recurrent_layers/simple_rnn#simplernn-class", 
    keras.layers.TimeDistributed = "https://keras.io/api/layers/recurrent_layers/time_distributed#timedistributed-class", 
    keras.layers.Bidirectional = "https://keras.io/api/layers/recurrent_layers/bidirectional#bidirectional-class", 
    keras.layers.ConvLSTM1D = "https://keras.io/api/layers/recurrent_layers/conv_lstm1d#convlstm1d-class", 
    keras.layers.ConvLSTM2D = "https://keras.io/api/layers/recurrent_layers/conv_lstm2d#convlstm2d-class", 
    keras.layers.ConvLSTM3D = "https://keras.io/api/layers/recurrent_layers/conv_lstm3d#convlstm3d-class", 
    keras.layers.RNN = "https://keras.io/api/layers/recurrent_layers/rnn#rnn-class", 
    keras.layers.TextVectorization = "https://keras.io/api/layers/preprocessing_layers/text/text_vectorization#textvectorization-class", 
    keras.layers.Normalization = "https://keras.io/api/layers/preprocessing_layers/numerical/normalization#normalization-class", 
    keras.layers.Discretization = "https://keras.io/api/layers/preprocessing_layers/numerical/discretization#discretization-class", 
    keras.layers.CategoryEncoding = "https://keras.io/api/layers/preprocessing_layers/categorical/category_encoding#categoryencoding-class", 
    keras.layers.Hashing = "https://keras.io/api/layers/preprocessing_layers/categorical/hashing#hashing-class", 
    keras.layers.HashedCrossing = "https://keras.io/api/layers/preprocessing_layers/categorical/hashed_crossing#hashedcrossing-class", 
    keras.layers.StringLookup = "https://keras.io/api/layers/preprocessing_layers/categorical/string_lookup#stringlookup-class", 
    keras.layers.IntegerLookup = "https://keras.io/api/layers/preprocessing_layers/categorical/integer_lookup#integerlookup-class", 
    keras.layers.Resizing = "https://keras.io/api/layers/preprocessing_layers/image_preprocessing/resizing#resizing-class", 
    keras.layers.Rescaling = "https://keras.io/api/layers/preprocessing_layers/image_preprocessing/rescaling#rescaling-class", 
    keras.layers.CenterCrop = "https://keras.io/api/layers/preprocessing_layers/image_preprocessing/center_crop#centercrop-class", 
    keras.layers.RandomCrop = "https://keras.io/api/layers/preprocessing_layers/image_augmentation/random_crop#randomcrop-class", 
    keras.layers.RandomFlip = "https://keras.io/api/layers/preprocessing_layers/image_augmentation/random_flip#randomflip-class", 
    keras.layers.RandomTranslation = "https://keras.io/api/layers/preprocessing_layers/image_augmentation/random_translation#randomtranslation-class", 
    keras.layers.RandomRotation = "https://keras.io/api/layers/preprocessing_layers/image_augmentation/random_rotation#randomrotation-class", 
    keras.layers.RandomZoom = "https://keras.io/api/layers/preprocessing_layers/image_augmentation/random_zoom#randomzoom-class", 
    keras.layers.RandomContrast = "https://keras.io/api/layers/preprocessing_layers/image_augmentation/random_contrast#randomcontrast-class", 
    keras.layers.RandomBrightness = "https://keras.io/api/layers/preprocessing_layers/image_augmentation/random_brightness#randombrightness-class", 
    keras.layers.BatchNormalization = "https://keras.io/api/layers/normalization_layers/batch_normalization#batchnormalization-class", 
    keras.layers.LayerNormalization = "https://keras.io/api/layers/normalization_layers/layer_normalization#layernormalization-class", 
    keras.layers.UnitNormalization = "https://keras.io/api/layers/normalization_layers/unit_normalization#unitnormalization-class", 
    keras.layers.GroupNormalization = "https://keras.io/api/layers/normalization_layers/group_normalization#groupnormalization-class", 
    keras.layers.Dropout = "https://keras.io/api/layers/regularization_layers/dropout#dropout-class", 
    keras.layers.SpatialDropout1D = "https://keras.io/api/layers/regularization_layers/spatial_dropout1d#spatialdropout1d-class", 
    keras.layers.SpatialDropout2D = "https://keras.io/api/layers/regularization_layers/spatial_dropout2d#spatialdropout2d-class", 
    keras.layers.SpatialDropout3D = "https://keras.io/api/layers/regularization_layers/spatial_dropout3d#spatialdropout3d-class", 
    keras.layers.GaussianDropout = "https://keras.io/api/layers/regularization_layers/gaussian_dropout#gaussiandropout-class", 
    keras.layers.GaussianNoise = "https://keras.io/api/layers/regularization_layers/gaussian_noise#gaussiannoise-class", 
    keras.layers.ActivityRegularization = "https://keras.io/api/layers/regularization_layers/activity_regularization#activityregularization-class", 
    keras.layers.MultiHeadAttention = "https://keras.io/api/layers/attention_layers/multi_head_attention#multiheadattention-class", 
    keras.layers.Attention = "https://keras.io/api/layers/attention_layers/attention#attention-class", 
    keras.layers.AdditiveAttention = "https://keras.io/api/layers/attention_layers/additive_attention#additiveattention-class", 
    keras.layers.Reshape = "https://keras.io/api/layers/reshaping_layers/reshape#reshape-class", 
    keras.layers.Flatten = "https://keras.io/api/layers/reshaping_layers/flatten#flatten-class", 
    keras.layers.RepeatVector = "https://keras.io/api/layers/reshaping_layers/repeat_vector#repeatvector-class", 
    keras.layers.Permute = "https://keras.io/api/layers/reshaping_layers/permute#permute-class", 
    keras.layers.Cropping1D = "https://keras.io/api/layers/reshaping_layers/cropping1d#cropping1d-class", 
    keras.layers.Cropping2D = "https://keras.io/api/layers/reshaping_layers/cropping2d#cropping2d-class", 
    keras.layers.Cropping3D = "https://keras.io/api/layers/reshaping_layers/cropping3d#cropping3d-class", 
    keras.layers.UpSampling1D = "https://keras.io/api/layers/reshaping_layers/up_sampling1d#upsampling1d-class", 
    keras.layers.UpSampling2D = "https://keras.io/api/layers/reshaping_layers/up_sampling2d#upsampling2d-class", 
    keras.layers.UpSampling3D = "https://keras.io/api/layers/reshaping_layers/up_sampling3d#upsampling3d-class", 
    keras.layers.ZeroPadding1D = "https://keras.io/api/layers/reshaping_layers/zero_padding1d#zeropadding1d-class", 
    keras.layers.ZeroPadding2D = "https://keras.io/api/layers/reshaping_layers/zero_padding2d#zeropadding2d-class", 
    keras.layers.ZeroPadding3D = "https://keras.io/api/layers/reshaping_layers/zero_padding3d#zeropadding3d-class", 
    keras.layers.Concatenate = "https://keras.io/api/layers/merging_layers/concatenate#concatenate-class", 
    keras.layers.Average = "https://keras.io/api/layers/merging_layers/average#average-class", 
    keras.layers.Maximum = "https://keras.io/api/layers/merging_layers/maximum#maximum-class", 
    keras.layers.Minimum = "https://keras.io/api/layers/merging_layers/minimum#minimum-class", 
    keras.layers.Add = "https://keras.io/api/layers/merging_layers/add#add-class", 
    keras.layers.Subtract = "https://keras.io/api/layers/merging_layers/subtract#subtract-class", 
    keras.layers.Multiply = "https://keras.io/api/layers/merging_layers/multiply#multiply-class", 
    keras.layers.Dot = "https://keras.io/api/layers/merging_layers/dot#dot-class", 
    keras.layers.ReLU = "https://keras.io/api/layers/activation_layers/relu#relu-class", 
    keras.layers.Softmax = "https://keras.io/api/layers/activation_layers/softmax#softmax-class", 
    keras.layers.LeakyReLU = "https://keras.io/api/layers/activation_layers/leaky_relu#leakyrelu-class", 
    keras.layers.PReLU = "https://keras.io/api/layers/activation_layers/prelu#prelu-class", 
    keras.layers.ELU = "https://keras.io/api/layers/activation_layers/elu#elu-class", 
    keras.layers.ThresholdedReLU = "https://keras.io/api/layers/activation_layers/threshold_relu#thresholdedrelu-class", 
    keras.callbacks.Callback = "https://keras.io/api/callbacks/base_callback#callback-class", 
    keras.callbacks.ModelCheckpoint = "https://keras.io/api/callbacks/model_checkpoint#modelcheckpoint-class", 
    keras.callbacks.BackupAndRestore = "https://keras.io/api/callbacks/backup_and_restore#backupandrestore-class", 
    keras.callbacks.TensorBoard = "https://keras.io/api/callbacks/tensorboard#tensorboard-class", 
    keras.callbacks.EarlyStopping = "https://keras.io/api/callbacks/early_stopping#earlystopping-class", 
    keras.callbacks.LearningRateScheduler = "https://keras.io/api/callbacks/learning_rate_scheduler#learningratescheduler-class", 
    keras.callbacks.ReduceLROnPlateau = "https://keras.io/api/callbacks/reduce_lr_on_plateau#reducelronplateau-class", 
    keras.callbacks.RemoteMonitor = "https://keras.io/api/callbacks/remote_monitor#remotemonitor-class", 
    keras.callbacks.LambdaCallback = "https://keras.io/api/callbacks/lambda_callback#lambdacallback-class", 
    keras.callbacks.TerminateOnNaN = "https://keras.io/api/callbacks/terminate_on_nan#terminateonnan-class", 
    keras.callbacks.CSVLogger = "https://keras.io/api/callbacks/csv_logger#csvlogger-class", 
    keras.callbacks.ProgbarLogger = "https://keras.io/api/callbacks/progbar_logger#progbarlogger-class", 
    keras.optimizers.Optimizer.apply_gradients = "https://keras.io/api/optimizers#applygradients-method", 
    keras.optimizers.Optimizer.variables = "https://keras.io/api/optimizers#variables-property", 
    keras.optimizers.SGD = "https://keras.io/api/optimizers/sgd#sgd-class", 
    keras.optimizers.RMSprop = "https://keras.io/api/optimizers/rmsprop#rmsprop-class", 
    keras.optimizers.Adam = "https://keras.io/api/optimizers/adam#adam-class", 
    keras.optimizers.AdamW = "https://keras.io/api/optimizers/adamw#adamw-class", 
    keras.optimizers.Adadelta = "https://keras.io/api/optimizers/adadelta#adadelta-class", 
    keras.optimizers.Adagrad = "https://keras.io/api/optimizers/adagrad#adagrad-class", 
    keras.optimizers.Adamax = "https://keras.io/api/optimizers/adamax#adamax-class", 
    keras.optimizers.Adafactor = "https://keras.io/api/optimizers/adafactor#adafactor-class", 
    keras.optimizers.Nadam = "https://keras.io/api/optimizers/Nadam#nadam-class", 
    keras.optimizers.Ftrl = "https://keras.io/api/optimizers/ftrl#ftrl-class", 
    keras.optimizers.schedules.ExponentialDecay = "https://keras.io/api/optimizers/learning_rate_schedules/exponential_decay#exponentialdecay-class", 
    keras.optimizers.schedules.PiecewiseConstantDecay = "https://keras.io/api/optimizers/learning_rate_schedules/piecewise_constant_decay#piecewiseconstantdecay-class", 
    keras.optimizers.schedules.PolynomialDecay = "https://keras.io/api/optimizers/learning_rate_schedules/polynomial_decay#polynomialdecay-class", 
    keras.optimizers.schedules.InverseTimeDecay = "https://keras.io/api/optimizers/learning_rate_schedules/inverse_time_decay#inversetimedecay-class", 
    keras.optimizers.schedules.CosineDecay = "https://keras.io/api/optimizers/learning_rate_schedules/cosine_decay#cosinedecay-class", 
    keras.optimizers.schedules.CosineDecayRestarts = "https://keras.io/api/optimizers/learning_rate_schedules/cosine_decay_restarts#cosinedecayrestarts-class", 
    keras.metrics.Accuracy = "https://keras.io/api/metrics/accuracy_metrics#accuracy-class", 
    keras.metrics.BinaryAccuracy = "https://keras.io/api/metrics/accuracy_metrics#binaryaccuracy-class", 
    keras.metrics.CategoricalAccuracy = "https://keras.io/api/metrics/accuracy_metrics#categoricalaccuracy-class", 
    keras.metrics.SparseCategoricalAccuracy = "https://keras.io/api/metrics/accuracy_metrics#sparsecategoricalaccuracy-class", 
    keras.metrics.TopKCategoricalAccuracy = "https://keras.io/api/metrics/accuracy_metrics#topkcategoricalaccuracy-class", 
    keras.metrics.SparseTopKCategoricalAccuracy = "https://keras.io/api/metrics/accuracy_metrics#sparsetopkcategoricalaccuracy-class", 
    keras.metrics.BinaryCrossentropy = "https://keras.io/api/metrics/probabilistic_metrics#binarycrossentropy-class", 
    keras.metrics.CategoricalCrossentropy = "https://keras.io/api/metrics/probabilistic_metrics#categoricalcrossentropy-class", 
    keras.metrics.SparseCategoricalCrossentropy = "https://keras.io/api/metrics/probabilistic_metrics#sparsecategoricalcrossentropy-class", 
    keras.metrics.KLDivergence = "https://keras.io/api/metrics/probabilistic_metrics#kldivergence-class", 
    keras.metrics.Poisson = "https://keras.io/api/metrics/probabilistic_metrics#poisson-class", 
    keras.metrics.MeanSquaredError = "https://keras.io/api/metrics/regression_metrics#meansquarederror-class", 
    keras.metrics.RootMeanSquaredError = "https://keras.io/api/metrics/regression_metrics#rootmeansquarederror-class", 
    keras.metrics.MeanAbsoluteError = "https://keras.io/api/metrics/regression_metrics#meanabsoluteerror-class", 
    keras.metrics.MeanAbsolutePercentageError = "https://keras.io/api/metrics/regression_metrics#meanabsolutepercentageerror-class", 
    keras.metrics.MeanSquaredLogarithmicError = "https://keras.io/api/metrics/regression_metrics#meansquaredlogarithmicerror-class", 
    keras.metrics.CosineSimilarity = "https://keras.io/api/metrics/regression_metrics#cosinesimilarity-class", 
    keras.metrics.LogCoshError = "https://keras.io/api/metrics/regression_metrics#logcosherror-class", 
    keras.metrics.AUC = "https://keras.io/api/metrics/classification_metrics#auc-class", 
    keras.metrics.Precision = "https://keras.io/api/metrics/classification_metrics#precision-class", 
    keras.metrics.Recall = "https://keras.io/api/metrics/classification_metrics#recall-class", 
    keras.metrics.TruePositives = "https://keras.io/api/metrics/classification_metrics#truepositives-class", 
    keras.metrics.TrueNegatives = "https://keras.io/api/metrics/classification_metrics#truenegatives-class", 
    keras.metrics.FalsePositives = "https://keras.io/api/metrics/classification_metrics#falsepositives-class", 
    keras.metrics.FalseNegatives = "https://keras.io/api/metrics/classification_metrics#falsenegatives-class", 
    keras.metrics.PrecisionAtRecall = "https://keras.io/api/metrics/classification_metrics#precisionatrecall-class", 
    keras.metrics.SensitivityAtSpecificity = "https://keras.io/api/metrics/classification_metrics#sensitivityatspecificity-class", 
    keras.metrics.SpecificityAtSensitivity = "https://keras.io/api/metrics/classification_metrics#specificityatsensitivity-class", 
    keras.metrics.MeanIoU = "https://keras.io/api/metrics/segmentation_metrics#meaniou-class", 
    keras.metrics.Hinge = "https://keras.io/api/metrics/hinge_metrics#hinge-class", 
    keras.metrics.SquaredHinge = "https://keras.io/api/metrics/hinge_metrics#squaredhinge-class", 
    keras.metrics.CategoricalHinge = "https://keras.io/api/metrics/hinge_metrics#categoricalhinge-class", 
    keras.losses.BinaryCrossentropy = "https://keras.io/api/losses/probabilistic_losses#binarycrossentropy-class", 
    keras.losses.CategoricalCrossentropy = "https://keras.io/api/losses/probabilistic_losses#categoricalcrossentropy-class", 
    keras.losses.SparseCategoricalCrossentropy = "https://keras.io/api/losses/probabilistic_losses#sparsecategoricalcrossentropy-class", 
    keras.losses.Poisson = "https://keras.io/api/losses/probabilistic_losses#poisson-class", 
    keras.losses.binary_crossentropy = "https://keras.io/api/losses/probabilistic_losses#binarycrossentropy-function", 
    keras.losses.categorical_crossentropy = "https://keras.io/api/losses/probabilistic_losses#categoricalcrossentropy-function", 
    keras.losses.sparse_categorical_crossentropy = "https://keras.io/api/losses/probabilistic_losses#sparsecategoricalcrossentropy-function", 
    keras.losses.poisson = "https://keras.io/api/losses/probabilistic_losses#poisson-function", 
    keras.losses.KLDivergence = "https://keras.io/api/losses/probabilistic_losses#kldivergence-class", 
    keras.losses.kl_divergence = "https://keras.io/api/losses/probabilistic_losses#kldivergence-function", 
    keras.losses.MeanSquaredError = "https://keras.io/api/losses/regression_losses#meansquarederror-class", 
    keras.losses.MeanAbsoluteError = "https://keras.io/api/losses/regression_losses#meanabsoluteerror-class", 
    keras.losses.MeanAbsolutePercentageError = "https://keras.io/api/losses/regression_losses#meanabsolutepercentageerror-class", 
    keras.losses.MeanSquaredLogarithmicError = "https://keras.io/api/losses/regression_losses#meansquaredlogarithmicerror-class", 
    keras.losses.CosineSimilarity = "https://keras.io/api/losses/regression_losses#cosinesimilarity-class", 
    keras.losses.mean_squared_error = "https://keras.io/api/losses/regression_losses#meansquarederror-function", 
    keras.losses.mean_absolute_error = "https://keras.io/api/losses/regression_losses#meanabsoluteerror-function", 
    keras.losses.mean_absolute_percentage_error = "https://keras.io/api/losses/regression_losses#meanabsolutepercentageerror-function", 
    keras.losses.mean_squared_logarithmic_error = "https://keras.io/api/losses/regression_losses#meansquaredlogarithmicerror-function", 
    keras.losses.cosine_similarity = "https://keras.io/api/losses/regression_losses#cosinesimilarity-function", 
    keras.losses.Huber = "https://keras.io/api/losses/regression_losses#huber-class", 
    keras.losses.huber = "https://keras.io/api/losses/regression_losses#huber-function", 
    keras.losses.LogCosh = "https://keras.io/api/losses/regression_losses#logcosh-class", 
    keras.losses.log_cosh = "https://keras.io/api/losses/regression_losses#logcosh-function", 
    keras.losses.Hinge = "https://keras.io/api/losses/hinge_losses#hinge-class", 
    keras.losses.SquaredHinge = "https://keras.io/api/losses/hinge_losses#squaredhinge-class", 
    keras.losses.CategoricalHinge = "https://keras.io/api/losses/hinge_losses#categoricalhinge-class", 
    keras.losses.hinge = "https://keras.io/api/losses/hinge_losses#hinge-function", 
    keras.losses.squared_hinge = "https://keras.io/api/losses/hinge_losses#squaredhinge-function", 
    keras.losses.categorical_hinge = "https://keras.io/api/losses/hinge_losses#categoricalhinge-function", 
    keras.utils.image_dataset_from_directory = "https://keras.io/api/data_loading/image#imagedatasetfromdirectory-function", 
    keras.utils.load_img = "https://keras.io/api/data_loading/image#loadimg-function", 
    keras.utils.img_to_array = "https://keras.io/api/data_loading/image#imgtoarray-function", 
    keras.utils.save_img = "https://keras.io/api/data_loading/image#saveimg-function", 
    keras.utils.timeseries_dataset_from_array = "https://keras.io/api/data_loading/timeseries#timeseriesdatasetfromarray-function", 
    keras.utils.text_dataset_from_directory = "https://keras.io/api/data_loading/text#textdatasetfromdirectory-function", 
    keras.utils.audio_dataset_from_directory = "https://keras.io/api/data_loading/audio#audiodatasetfromdirectory-function", 
    keras.datasets.mnist.load_data = "https://keras.io/api/datasets/mnist#loaddata-function", 
    keras.datasets.cifar10.load_data = "https://keras.io/api/datasets/cifar10#loaddata-function", 
    keras.datasets.cifar100.load_data = "https://keras.io/api/datasets/cifar100#loaddata-function", 
    keras.datasets.imdb.load_data = "https://keras.io/api/datasets/imdb#loaddata-function", 
    keras.datasets.imdb.get_word_index = "https://keras.io/api/datasets/imdb#getwordindex-function", 
    keras.datasets.reuters.load_data = "https://keras.io/api/datasets/reuters#loaddata-function", 
    keras.datasets.reuters.get_word_index = "https://keras.io/api/datasets/reuters#getwordindex-function", 
    keras.datasets.fashion_mnist.load_data = "https://keras.io/api/datasets/fashion_mnist#loaddata-function", 
    keras.datasets.boston_housing.load_data = "https://keras.io/api/datasets/boston_housing#loaddata-function", 
    keras.applications.Xception = "https://keras.io/api/applications/xception#xception-function", 
    keras.applications.EfficientNetB0 = "https://keras.io/api/applications/efficientnet#efficientnetb0-function", 
    keras.applications.EfficientNetB1 = "https://keras.io/api/applications/efficientnet#efficientnetb1-function", 
    keras.applications.EfficientNetB2 = "https://keras.io/api/applications/efficientnet#efficientnetb2-function", 
    keras.applications.EfficientNetB3 = "https://keras.io/api/applications/efficientnet#efficientnetb3-function", 
    keras.applications.EfficientNetB4 = "https://keras.io/api/applications/efficientnet#efficientnetb4-function", 
    keras.applications.EfficientNetB5 = "https://keras.io/api/applications/efficientnet#efficientnetb5-function", 
    keras.applications.EfficientNetB6 = "https://keras.io/api/applications/efficientnet#efficientnetb6-function", 
    keras.applications.EfficientNetB7 = "https://keras.io/api/applications/efficientnet#efficientnetb7-function", 
    keras.applications.EfficientNetV2B0 = "https://keras.io/api/applications/efficientnet_v2#efficientnetv2b0-function", 
    keras.applications.EfficientNetV2B1 = "https://keras.io/api/applications/efficientnet_v2#efficientnetv2b1-function", 
    keras.applications.EfficientNetV2B2 = "https://keras.io/api/applications/efficientnet_v2#efficientnetv2b2-function", 
    keras.applications.EfficientNetV2B3 = "https://keras.io/api/applications/efficientnet_v2#efficientnetv2b3-function", 
    keras.applications.EfficientNetV2S = "https://keras.io/api/applications/efficientnet_v2#efficientnetv2s-function", 
    keras.applications.EfficientNetV2M = "https://keras.io/api/applications/efficientnet_v2#efficientnetv2m-function", 
    keras.applications.EfficientNetV2L = "https://keras.io/api/applications/efficientnet_v2#efficientnetv2l-function", 
    keras.applications.ConvNeXtTiny = "https://keras.io/api/applications/convnext#convnexttiny-function", 
    keras.applications.ConvNeXtSmall = "https://keras.io/api/applications/convnext#convnextsmall-function", 
    keras.applications.ConvNeXtBase = "https://keras.io/api/applications/convnext#convnextbase-function", 
    keras.applications.ConvNeXtLarge = "https://keras.io/api/applications/convnext#convnextlarge-function", 
    keras.applications.ConvNeXtXLarge = "https://keras.io/api/applications/convnext#convnextxlarge-function", 
    keras.applications.VGG16 = "https://keras.io/api/applications/vgg#vgg16-function", 
    keras.applications.VGG19 = "https://keras.io/api/applications/vgg#vgg19-function", 
    keras.applications.ResNet50 = "https://keras.io/api/applications/resnet#resnet50-function", 
    keras.applications.ResNet101 = "https://keras.io/api/applications/resnet#resnet101-function", 
    keras.applications.ResNet152 = "https://keras.io/api/applications/resnet#resnet152-function", 
    keras.applications.ResNet50V2 = "https://keras.io/api/applications/resnet#resnet50v2-function", 
    keras.applications.ResNet101V2 = "https://keras.io/api/applications/resnet#resnet101v2-function", 
    keras.applications.ResNet152V2 = "https://keras.io/api/applications/resnet#resnet152v2-function", 
    keras.applications.MobileNet = "https://keras.io/api/applications/mobilenet#mobilenet-function", 
    keras.applications.MobileNetV2 = "https://keras.io/api/applications/mobilenet#mobilenetv2-function", 
    keras.applications.MobileNetV3Small = "https://keras.io/api/applications/mobilenet#mobilenetv3small-function", 
    keras.applications.MobileNetV3Large = "https://keras.io/api/applications/mobilenet#mobilenetv3large-function", 
    keras.applications.DenseNet121 = "https://keras.io/api/applications/densenet#densenet121-function", 
    keras.applications.DenseNet169 = "https://keras.io/api/applications/densenet#densenet169-function", 
    keras.applications.DenseNet201 = "https://keras.io/api/applications/densenet#densenet201-function", 
    keras.applications.NASNetLarge = "https://keras.io/api/applications/nasnet#nasnetlarge-function", 
    keras.applications.NASNetMobile = "https://keras.io/api/applications/nasnet#nasnetmobile-function", 
    keras.applications.InceptionV3 = "https://keras.io/api/applications/inceptionv3#inceptionv3-function", 
    keras.applications.InceptionResNetV2 = "https://keras.io/api/applications/inceptionresnetv2#inceptionresnetv2-function", 
    keras.mixed_precision.Policy = "https://keras.io/api/mixed_precision/policy#policy-class", 
    keras.mixed_precision.global_policy = "https://keras.io/api/mixed_precision/policy#globalpolicy-function", 
    keras.mixed_precision.set_global_policy = "https://keras.io/api/mixed_precision/policy#setglobalpolicy-function", 
    keras.mixed_precision.LossScaleOptimizer = "https://keras.io/api/mixed_precision/loss_scale_optimizer#lossscaleoptimizer-class", 
    keras.utils.plot_model = "https://keras.io/api/utils/model_plotting_utils#plotmodel-function", 
    keras.utils.model_to_dot = "https://keras.io/api/utils/model_plotting_utils#modeltodot-function", 
    keras.utils.FeatureSpace = "https://keras.io/api/utils/feature_space#featurespace-class", 
    keras.utils.set_random_seed = "https://keras.io/api/utils/python_utils#setrandomseed-function", 
    keras.utils.split_dataset = "https://keras.io/api/utils/python_utils#splitdataset-function", 
    keras.utils.get_file = "https://keras.io/api/utils/python_utils#getfile-function", 
    keras.utils.Progbar = "https://keras.io/api/utils/python_utils#progbar-class", 
    keras.utils.Sequence = "https://keras.io/api/utils/python_utils#sequence-class", 
    keras.utils.to_categorical = "https://keras.io/api/utils/python_utils#tocategorical-function", 
    keras.utils.normalize = "https://keras.io/api/utils/python_utils#normalize-function", 
    keras.backend.clear_session = "https://keras.io/api/utils/backend_utils#clearsession-function", 
    keras.backend.floatx = "https://keras.io/api/utils/backend_utils#floatx-function", 
    keras.backend.set_floatx = "https://keras.io/api/utils/backend_utils#setfloatx-function", 
    keras.backend.image_data_format = "https://keras.io/api/utils/backend_utils#imagedataformat-function", 
    keras.backend.set_image_data_format = "https://keras.io/api/utils/backend_utils#setimagedataformat-function", 
    keras.backend.epsilon = "https://keras.io/api/utils/backend_utils#epsilon-function", 
    keras.backend.set_epsilon = "https://keras.io/api/utils/backend_utils#setepsilon-function", 
    keras.backend.is_keras_tensor = "https://keras.io/api/utils/backend_utils#iskerastensor-function", 
    keras.backend.get_uid = "https://keras.io/api/utils/backend_utils#getuid-function", 
    keras.backend.rnn = "https://keras.io/api/utils/backend_utils#rnn-function", 
    keras.Model = "https://keras.io/api/models/model#model-class", 
    keras.Model.summary = "https://keras.io/api/models/model#summary-method", 
    keras.Model.get_layer = "https://keras.io/api/models/model#getlayer-method", 
    keras.Sequential = "https://keras.io/api/models/sequential#sequential-class", 
    keras.Sequential.add = "https://keras.io/api/models/sequential#add-method", 
    keras.Sequential.pop = "https://keras.io/api/models/sequential#pop-method", 
    keras.Model.compile = "https://keras.io/api/models/model_training_apis#compile-method", 
    keras.Model.fit = "https://keras.io/api/models/model_training_apis#fit-method", 
    keras.Model.evaluate = "https://keras.io/api/models/model_training_apis#evaluate-method", 
    keras.Model.predict = "https://keras.io/api/models/model_training_apis#predict-method", 
    keras.Model.train_on_batch = "https://keras.io/api/models/model_training_apis#trainonbatch-method", 
    keras.Model.test_on_batch = "https://keras.io/api/models/model_training_apis#testonbatch-method", 
    keras.Model.predict_on_batch = "https://keras.io/api/models/model_training_apis#predictonbatch-method", 
    keras.Model.save = "https://keras.io/api/models/model_saving_apis/model_saving_and_loading#save-method", 
    keras.saving.save_model = "https://keras.io/api/models/model_saving_apis/model_saving_and_loading#savemodel-function", 
    keras.saving.load_model = "https://keras.io/api/models/model_saving_apis/model_saving_and_loading#loadmodel-function", 
    keras.Model.save_weights = "https://keras.io/api/models/model_saving_apis/weights_saving_and_loading#saveweights-method", 
    keras.Model.load_weights = "https://keras.io/api/models/model_saving_apis/weights_saving_and_loading#loadweights-method", 
    keras.Model.get_config = "https://keras.io/api/models/model_saving_apis/model_config_serialization#getconfig-method", 
    keras.Model.from_config = "https://keras.io/api/models/model_saving_apis/model_config_serialization#fromconfig-method", 
    keras.models.clone_model = "https://keras.io/api/models/model_saving_apis/model_config_serialization#clonemodel-function", 
    keras.saving.serialize_keras_object = "https://keras.io/api/models/model_saving_apis/serialization_utils#serializekerasobject-function", 
    keras.saving.deserialize_keras_object = "https://keras.io/api/models/model_saving_apis/serialization_utils#deserializekerasobject-function", 
    keras.saving.custom_object_scope = "https://keras.io/api/models/model_saving_apis/serialization_utils#customobjectscope-class", 
    keras.saving.get_custom_objects = "https://keras.io/api/models/model_saving_apis/serialization_utils#getcustomobjects-function", 
    keras.saving.register_keras_serializable = "https://keras.io/api/models/model_saving_apis/serialization_utils#registerkerasserializable-function", 
    keras.layers.Layer = "https://keras.io/api/layers/base_layer#layer-class", 
    keras.layers.Layer.weights = "https://keras.io/api/layers/base_layer#weights-property", 
    keras.layers.Layer.trainable_weights = "https://keras.io/api/layers/base_layer#trainableweights-property", 
    keras.layers.Layer.non_trainable_weights = "https://keras.io/api/layers/base_layer#nontrainableweights-property", 
    keras.layers.Layer.add_weight = "https://keras.io/api/layers/base_layer#addweight-method", 
    keras.layers.Layer.trainable = "https://keras.io/api/layers/base_layer#trainable-property", 
    keras.layers.Layer.get_weights = "https://keras.io/api/layers/base_layer#getweights-method", 
    keras.layers.Layer.set_weights = "https://keras.io/api/layers/base_layer#setweights-method", 
    keras.Model.get_config = "https://keras.io/api/layers/base_layer#getconfig-method", 
    keras.layers.Layer.add_loss = "https://keras.io/api/layers/base_layer#addloss-method", 
    keras.layers.Layer.losses = "https://keras.io/api/layers/base_layer#losses-property", 
    keras.activations.relu = "https://keras.io/api/layers/activations#relu-function", 
    keras.activations.sigmoid = "https://keras.io/api/layers/activations#sigmoid-function", 
    keras.activations.softmax = "https://keras.io/api/layers/activations#softmax-function", 
    keras.activations.softplus = "https://keras.io/api/layers/activations#softplus-function", 
    keras.activations.softsign = "https://keras.io/api/layers/activations#softsign-function", 
    keras.activations.tanh = "https://keras.io/api/layers/activations#tanh-function", 
    keras.activations.selu = "https://keras.io/api/layers/activations#selu-function", 
    keras.activations.elu = "https://keras.io/api/layers/activations#elu-function", 
    keras.activations.exponential = "https://keras.io/api/layers/activations#exponential-function", 
    keras.activations.leaky_relu = "https://keras.io/api/layers/activations#leakyrelu-function", 
    keras.activations.relu6 = "https://keras.io/api/layers/activations#relu6-function", 
    keras.activations.silu = "https://keras.io/api/layers/activations#silu-function", 
    keras.activations.gelu = "https://keras.io/api/layers/activations#gelu-function", 
    keras.activations.hard_sigmoid = "https://keras.io/api/layers/activations#hardsigmoid-function", 
    keras.activations.linear = "https://keras.io/api/layers/activations#linear-function", 
    keras.activations.mish = "https://keras.io/api/layers/activations#mish-function", 
    keras.activations.log_softmax = "https://keras.io/api/layers/activations#logsoftmax-function", 
    keras.initializers.RandomNormal = "https://keras.io/api/layers/initializers#randomnormal-class", 
    keras.initializers.RandomUniform = "https://keras.io/api/layers/initializers#randomuniform-class", 
    keras.initializers.TruncatedNormal = "https://keras.io/api/layers/initializers#truncatednormal-class", 
    keras.initializers.Zeros = "https://keras.io/api/layers/initializers#zeros-class", 
    keras.initializers.Ones = "https://keras.io/api/layers/initializers#ones-class", 
    keras.initializers.GlorotNormal = "https://keras.io/api/layers/initializers#glorotnormal-class", 
    keras.initializers.GlorotUniform = "https://keras.io/api/layers/initializers#glorotuniform-class", 
    keras.initializers.HeNormal = "https://keras.io/api/layers/initializers#henormal-class", 
    keras.initializers.HeUniform = "https://keras.io/api/layers/initializers#heuniform-class", 
    keras.initializers.Orthogonal = "https://keras.io/api/layers/initializers#orthogonal-class", 
    keras.initializers.Constant = "https://keras.io/api/layers/initializers#constant-class", 
    keras.initializers.VarianceScaling = "https://keras.io/api/layers/initializers#variancescaling-class", 
    keras.regularizers.L1 = "https://keras.io/api/layers/regularizers#l1-class", 
    keras.regularizers.L2 = "https://keras.io/api/layers/regularizers#l2-class", 
    keras.regularizers.L1L2 = "https://keras.io/api/layers/regularizers#l1l2-class", 
    keras.regularizers.OrthogonalRegularizer = "https://keras.io/api/layers/regularizers#orthogonalregularizer-class", 
    keras.constraints.MaxNorm = "https://keras.io/api/layers/constraints#maxnorm-class", 
    keras.constraints.MinMaxNorm = "https://keras.io/api/layers/constraints#minmaxnorm-class", 
    keras.constraints.NonNeg = "https://keras.io/api/layers/constraints#nonneg-class", 
    keras.constraints.UnitNorm = "https://keras.io/api/layers/constraints#unitnorm-class", 
    keras.Input = "https://keras.io/api/layers/core_layers/input#input-function", 
    keras.layers.Dense = "https://keras.io/api/layers/core_layers/dense#dense-class", 
    keras.layers.Activation = "https://keras.io/api/layers/core_layers/activation#activation-class", 
    keras.layers.Embedding = "https://keras.io/api/layers/core_layers/embedding#embedding-class", 
    keras.layers.Masking = "https://keras.io/api/layers/core_layers/masking#masking-class", 
    keras.layers.Lambda = "https://keras.io/api/layers/core_layers/lambda#lambda-class", 
    keras.layers.Conv1D = "https://keras.io/api/layers/convolution_layers/convolution1d#conv1d-class", 
    keras.layers.Conv2D = "https://keras.io/api/layers/convolution_layers/convolution2d#conv2d-class", 
    keras.layers.Conv3D = "https://keras.io/api/layers/convolution_layers/convolution3d#conv3d-class", 
    keras.layers.SeparableConv1D = "https://keras.io/api/layers/convolution_layers/separable_convolution1d#separableconv1d-class", 
    keras.layers.SeparableConv2D = "https://keras.io/api/layers/convolution_layers/separable_convolution2d#separableconv2d-class", 
    keras.layers.DepthwiseConv2D = "https://keras.io/api/layers/convolution_layers/depthwise_convolution2d#depthwiseconv2d-class", 
    keras.layers.Conv1DTranspose = "https://keras.io/api/layers/convolution_layers/convolution1d_transpose#conv1dtranspose-class", 
    keras.layers.Conv2DTranspose = "https://keras.io/api/layers/convolution_layers/convolution2d_transpose#conv2dtranspose-class", 
    keras.layers.Conv3DTranspose = "https://keras.io/api/layers/convolution_layers/convolution3d_transpose#conv3dtranspose-class", 
    keras.layers.MaxPooling1D = "https://keras.io/api/layers/pooling_layers/max_pooling1d#maxpooling1d-class", 
    keras.layers.MaxPooling2D = "https://keras.io/api/layers/pooling_layers/max_pooling2d#maxpooling2d-class", 
    keras.layers.MaxPooling3D = "https://keras.io/api/layers/pooling_layers/max_pooling3d#maxpooling3d-class", 
    keras.layers.AveragePooling1D = "https://keras.io/api/layers/pooling_layers/average_pooling1d#averagepooling1d-class", 
    keras.layers.AveragePooling2D = "https://keras.io/api/layers/pooling_layers/average_pooling2d#averagepooling2d-class", 
    keras.layers.AveragePooling3D = "https://keras.io/api/layers/pooling_layers/average_pooling3d#averagepooling3d-class", 
    keras.layers.GlobalMaxPooling1D = "https://keras.io/api/layers/pooling_layers/global_max_pooling1d#globalmaxpooling1d-class", 
    keras.layers.GlobalMaxPooling2D = "https://keras.io/api/layers/pooling_layers/global_max_pooling2d#globalmaxpooling2d-class", 
    keras.layers.GlobalMaxPooling3D = "https://keras.io/api/layers/pooling_layers/global_max_pooling3d#globalmaxpooling3d-class", 
    keras.layers.GlobalAveragePooling1D = "https://keras.io/api/layers/pooling_layers/global_average_pooling1d#globalaveragepooling1d-class", 
    keras.layers.GlobalAveragePooling2D = "https://keras.io/api/layers/pooling_layers/global_average_pooling2d#globalaveragepooling2d-class", 
    keras.layers.GlobalAveragePooling3D = "https://keras.io/api/layers/pooling_layers/global_average_pooling3d#globalaveragepooling3d-class", 
    keras.layers.LSTM = "https://keras.io/api/layers/recurrent_layers/lstm#lstm-class", 
    keras.layers.GRU = "https://keras.io/api/layers/recurrent_layers/gru#gru-class", 
    keras.layers.SimpleRNN = "https://keras.io/api/layers/recurrent_layers/simple_rnn#simplernn-class", 
    keras.layers.TimeDistributed = "https://keras.io/api/layers/recurrent_layers/time_distributed#timedistributed-class", 
    keras.layers.Bidirectional = "https://keras.io/api/layers/recurrent_layers/bidirectional#bidirectional-class", 
    keras.layers.ConvLSTM1D = "https://keras.io/api/layers/recurrent_layers/conv_lstm1d#convlstm1d-class", 
    keras.layers.ConvLSTM2D = "https://keras.io/api/layers/recurrent_layers/conv_lstm2d#convlstm2d-class", 
    keras.layers.ConvLSTM3D = "https://keras.io/api/layers/recurrent_layers/conv_lstm3d#convlstm3d-class", 
    keras.layers.RNN = "https://keras.io/api/layers/recurrent_layers/rnn#rnn-class", 
    keras.layers.TextVectorization = "https://keras.io/api/layers/preprocessing_layers/text/text_vectorization#textvectorization-class", 
    keras.layers.Normalization = "https://keras.io/api/layers/preprocessing_layers/numerical/normalization#normalization-class", 
    keras.layers.Discretization = "https://keras.io/api/layers/preprocessing_layers/numerical/discretization#discretization-class", 
    keras.layers.CategoryEncoding = "https://keras.io/api/layers/preprocessing_layers/categorical/category_encoding#categoryencoding-class", 
    keras.layers.Hashing = "https://keras.io/api/layers/preprocessing_layers/categorical/hashing#hashing-class", 
    keras.layers.HashedCrossing = "https://keras.io/api/layers/preprocessing_layers/categorical/hashed_crossing#hashedcrossing-class", 
    keras.layers.StringLookup = "https://keras.io/api/layers/preprocessing_layers/categorical/string_lookup#stringlookup-class", 
    keras.layers.IntegerLookup = "https://keras.io/api/layers/preprocessing_layers/categorical/integer_lookup#integerlookup-class", 
    keras.layers.Resizing = "https://keras.io/api/layers/preprocessing_layers/image_preprocessing/resizing#resizing-class", 
    keras.layers.Rescaling = "https://keras.io/api/layers/preprocessing_layers/image_preprocessing/rescaling#rescaling-class", 
    keras.layers.CenterCrop = "https://keras.io/api/layers/preprocessing_layers/image_preprocessing/center_crop#centercrop-class", 
    keras.layers.RandomCrop = "https://keras.io/api/layers/preprocessing_layers/image_augmentation/random_crop#randomcrop-class", 
    keras.layers.RandomFlip = "https://keras.io/api/layers/preprocessing_layers/image_augmentation/random_flip#randomflip-class", 
    keras.layers.RandomTranslation = "https://keras.io/api/layers/preprocessing_layers/image_augmentation/random_translation#randomtranslation-class", 
    keras.layers.RandomRotation = "https://keras.io/api/layers/preprocessing_layers/image_augmentation/random_rotation#randomrotation-class", 
    keras.layers.RandomZoom = "https://keras.io/api/layers/preprocessing_layers/image_augmentation/random_zoom#randomzoom-class", 
    keras.layers.RandomContrast = "https://keras.io/api/layers/preprocessing_layers/image_augmentation/random_contrast#randomcontrast-class", 
    keras.layers.RandomBrightness = "https://keras.io/api/layers/preprocessing_layers/image_augmentation/random_brightness#randombrightness-class", 
    keras.layers.BatchNormalization = "https://keras.io/api/layers/normalization_layers/batch_normalization#batchnormalization-class", 
    keras.layers.LayerNormalization = "https://keras.io/api/layers/normalization_layers/layer_normalization#layernormalization-class", 
    keras.layers.UnitNormalization = "https://keras.io/api/layers/normalization_layers/unit_normalization#unitnormalization-class", 
    keras.layers.GroupNormalization = "https://keras.io/api/layers/normalization_layers/group_normalization#groupnormalization-class", 
    keras.layers.Dropout = "https://keras.io/api/layers/regularization_layers/dropout#dropout-class", 
    keras.layers.SpatialDropout1D = "https://keras.io/api/layers/regularization_layers/spatial_dropout1d#spatialdropout1d-class", 
    keras.layers.SpatialDropout2D = "https://keras.io/api/layers/regularization_layers/spatial_dropout2d#spatialdropout2d-class", 
    keras.layers.SpatialDropout3D = "https://keras.io/api/layers/regularization_layers/spatial_dropout3d#spatialdropout3d-class", 
    keras.layers.GaussianDropout = "https://keras.io/api/layers/regularization_layers/gaussian_dropout#gaussiandropout-class", 
    keras.layers.GaussianNoise = "https://keras.io/api/layers/regularization_layers/gaussian_noise#gaussiannoise-class", 
    keras.layers.ActivityRegularization = "https://keras.io/api/layers/regularization_layers/activity_regularization#activityregularization-class", 
    keras.layers.MultiHeadAttention = "https://keras.io/api/layers/attention_layers/multi_head_attention#multiheadattention-class", 
    keras.layers.Attention = "https://keras.io/api/layers/attention_layers/attention#attention-class", 
    keras.layers.AdditiveAttention = "https://keras.io/api/layers/attention_layers/additive_attention#additiveattention-class", 
    keras.layers.Reshape = "https://keras.io/api/layers/reshaping_layers/reshape#reshape-class", 
    keras.layers.Flatten = "https://keras.io/api/layers/reshaping_layers/flatten#flatten-class", 
    keras.layers.RepeatVector = "https://keras.io/api/layers/reshaping_layers/repeat_vector#repeatvector-class", 
    keras.layers.Permute = "https://keras.io/api/layers/reshaping_layers/permute#permute-class", 
    keras.layers.Cropping1D = "https://keras.io/api/layers/reshaping_layers/cropping1d#cropping1d-class", 
    keras.layers.Cropping2D = "https://keras.io/api/layers/reshaping_layers/cropping2d#cropping2d-class", 
    keras.layers.Cropping3D = "https://keras.io/api/layers/reshaping_layers/cropping3d#cropping3d-class", 
    keras.layers.UpSampling1D = "https://keras.io/api/layers/reshaping_layers/up_sampling1d#upsampling1d-class", 
    keras.layers.UpSampling2D = "https://keras.io/api/layers/reshaping_layers/up_sampling2d#upsampling2d-class", 
    keras.layers.UpSampling3D = "https://keras.io/api/layers/reshaping_layers/up_sampling3d#upsampling3d-class", 
    keras.layers.ZeroPadding1D = "https://keras.io/api/layers/reshaping_layers/zero_padding1d#zeropadding1d-class", 
    keras.layers.ZeroPadding2D = "https://keras.io/api/layers/reshaping_layers/zero_padding2d#zeropadding2d-class", 
    keras.layers.ZeroPadding3D = "https://keras.io/api/layers/reshaping_layers/zero_padding3d#zeropadding3d-class", 
    keras.layers.Concatenate = "https://keras.io/api/layers/merging_layers/concatenate#concatenate-class", 
    keras.layers.Average = "https://keras.io/api/layers/merging_layers/average#average-class", 
    keras.layers.Maximum = "https://keras.io/api/layers/merging_layers/maximum#maximum-class", 
    keras.layers.Minimum = "https://keras.io/api/layers/merging_layers/minimum#minimum-class", 
    keras.layers.Add = "https://keras.io/api/layers/merging_layers/add#add-class", 
    keras.layers.Subtract = "https://keras.io/api/layers/merging_layers/subtract#subtract-class", 
    keras.layers.Multiply = "https://keras.io/api/layers/merging_layers/multiply#multiply-class", 
    keras.layers.Dot = "https://keras.io/api/layers/merging_layers/dot#dot-class", 
    keras.layers.ReLU = "https://keras.io/api/layers/activation_layers/relu#relu-class", 
    keras.layers.Softmax = "https://keras.io/api/layers/activation_layers/softmax#softmax-class", 
    keras.layers.LeakyReLU = "https://keras.io/api/layers/activation_layers/leaky_relu#leakyrelu-class", 
    keras.layers.PReLU = "https://keras.io/api/layers/activation_layers/prelu#prelu-class", 
    keras.layers.ELU = "https://keras.io/api/layers/activation_layers/elu#elu-class", 
    keras.callbacks.Callback = "https://keras.io/api/callbacks/base_callback#callback-class", 
    keras.callbacks.ModelCheckpoint = "https://keras.io/api/callbacks/model_checkpoint#modelcheckpoint-class", 
    keras.callbacks.TensorBoard = "https://keras.io/api/callbacks/tensorboard#tensorboard-class", 
    keras.callbacks.EarlyStopping = "https://keras.io/api/callbacks/early_stopping#earlystopping-class", 
    keras.callbacks.LearningRateScheduler = "https://keras.io/api/callbacks/learning_rate_scheduler#learningratescheduler-class", 
    keras.callbacks.ReduceLROnPlateau = "https://keras.io/api/callbacks/reduce_lr_on_plateau#reducelronplateau-class", 
    keras.callbacks.RemoteMonitor = "https://keras.io/api/callbacks/remote_monitor#remotemonitor-class", 
    keras.callbacks.LambdaCallback = "https://keras.io/api/callbacks/lambda_callback#lambdacallback-class", 
    keras.callbacks.TerminateOnNaN = "https://keras.io/api/callbacks/terminate_on_nan#terminateonnan-class", 
    keras.callbacks.CSVLogger = "https://keras.io/api/callbacks/csv_logger#csvlogger-class", 
    keras.callbacks.ProgbarLogger = "https://keras.io/api/callbacks/progbar_logger#progbarlogger-class", 
    keras.ops.absolute = "https://keras.io/api/ops/numpy#absolute-function", 
    keras.ops.add = "https://keras.io/api/ops/numpy#add-function", 
    keras.ops.all = "https://keras.io/api/ops/numpy#all-function", 
    keras.ops.amax = "https://keras.io/api/ops/numpy#amax-function", 
    keras.ops.amin = "https://keras.io/api/ops/numpy#amin-function", 
    keras.ops.any = "https://keras.io/api/ops/numpy#any-function", 
    keras.ops.append = "https://keras.io/api/ops/numpy#append-function", 
    keras.ops.arange = "https://keras.io/api/ops/numpy#arange-function", 
    keras.ops.arccos = "https://keras.io/api/ops/numpy#arccos-function", 
    keras.ops.arcsin = "https://keras.io/api/ops/numpy#arcsin-function", 
    keras.ops.arcsinh = "https://keras.io/api/ops/numpy#arcsinh-function", 
    keras.ops.arctan = "https://keras.io/api/ops/numpy#arctan-function", 
    keras.ops.arctan2 = "https://keras.io/api/ops/numpy#arctan2-function", 
    keras.ops.arctanh = "https://keras.io/api/ops/numpy#arctanh-function", 
    keras.ops.argmax = "https://keras.io/api/ops/numpy#argmax-function", 
    keras.ops.argmin = "https://keras.io/api/ops/numpy#argmin-function", 
    keras.ops.argsort = "https://keras.io/api/ops/numpy#argsort-function", 
    keras.ops.array = "https://keras.io/api/ops/numpy#array-function", 
    keras.ops.average = "https://keras.io/api/ops/numpy#average-function", 
    keras.ops.bincount = "https://keras.io/api/ops/numpy#bincount-function", 
    keras.ops.broadcast_to = "https://keras.io/api/ops/numpy#broadcastto-function", 
    keras.ops.ceil = "https://keras.io/api/ops/numpy#ceil-function", 
    keras.ops.clip = "https://keras.io/api/ops/numpy#clip-function", 
    keras.ops.concatenate = "https://keras.io/api/ops/numpy#concatenate-function", 
    keras.ops.conj = "https://keras.io/api/ops/numpy#conj-function", 
    keras.ops.conjugate = "https://keras.io/api/ops/numpy#conjugate-function", 
    keras.ops.copy = "https://keras.io/api/ops/numpy#copy-function", 
    keras.ops.cos = "https://keras.io/api/ops/numpy#cos-function", 
    keras.ops.cosh = "https://keras.io/api/ops/numpy#cosh-function", 
    keras.ops.count_nonzero = "https://keras.io/api/ops/numpy#countnonzero-function", 
    keras.ops.cross = "https://keras.io/api/ops/numpy#cross-function", 
    keras.ops.cumprod = "https://keras.io/api/ops/numpy#cumprod-function", 
    keras.ops.cumsum = "https://keras.io/api/ops/numpy#cumsum-function", 
    keras.ops.diag = "https://keras.io/api/ops/numpy#diag-function", 
    keras.ops.diagonal = "https://keras.io/api/ops/numpy#diagonal-function", 
    keras.ops.digitize = "https://keras.io/api/ops/numpy#digitize-function", 
    keras.ops.divide = "https://keras.io/api/ops/numpy#divide-function", 
    keras.ops.dot = "https://keras.io/api/ops/numpy#dot-function", 
    keras.ops.einsum = "https://keras.io/api/ops/numpy#einsum-function", 
    keras.ops.empty = "https://keras.io/api/ops/numpy#empty-function", 
    keras.ops.equal = "https://keras.io/api/ops/numpy#equal-function", 
    keras.ops.exp = "https://keras.io/api/ops/numpy#exp-function", 
    keras.ops.expand_dims = "https://keras.io/api/ops/numpy#expanddims-function", 
    keras.ops.expm1 = "https://keras.io/api/ops/numpy#expm1-function", 
    keras.ops.eye = "https://keras.io/api/ops/numpy#eye-function", 
    keras.ops.flip = "https://keras.io/api/ops/numpy#flip-function", 
    keras.ops.floor = "https://keras.io/api/ops/numpy#floor-function", 
    keras.ops.full = "https://keras.io/api/ops/numpy#full-function", 
    keras.ops.full_like = "https://keras.io/api/ops/numpy#fulllike-function", 
    keras.ops.get_item = "https://keras.io/api/ops/numpy#getitem-function", 
    keras.ops.greater = "https://keras.io/api/ops/numpy#greater-function", 
    keras.ops.greater_equal = "https://keras.io/api/ops/numpy#greaterequal-function", 
    keras.ops.hstack = "https://keras.io/api/ops/numpy#hstack-function", 
    keras.ops.identity = "https://keras.io/api/ops/numpy#identity-function", 
    keras.ops.imag = "https://keras.io/api/ops/numpy#imag-function", 
    keras.ops.isclose = "https://keras.io/api/ops/numpy#isclose-function", 
    keras.ops.isfinite = "https://keras.io/api/ops/numpy#isfinite-function", 
    keras.ops.isinf = "https://keras.io/api/ops/numpy#isinf-function", 
    keras.ops.isnan = "https://keras.io/api/ops/numpy#isnan-function", 
    keras.ops.less = "https://keras.io/api/ops/numpy#less-function", 
    keras.ops.less_equal = "https://keras.io/api/ops/numpy#lessequal-function", 
    keras.ops.linspace = "https://keras.io/api/ops/numpy#linspace-function", 
    keras.ops.log = "https://keras.io/api/ops/numpy#log-function", 
    keras.ops.log10 = "https://keras.io/api/ops/numpy#log10-function", 
    keras.ops.log1p = "https://keras.io/api/ops/numpy#log1p-function", 
    keras.ops.log2 = "https://keras.io/api/ops/numpy#log2-function", 
    keras.ops.logaddexp = "https://keras.io/api/ops/numpy#logaddexp-function", 
    keras.ops.logical_and = "https://keras.io/api/ops/numpy#logicaland-function", 
    keras.ops.logical_not = "https://keras.io/api/ops/numpy#logicalnot-function", 
    keras.ops.logical_or = "https://keras.io/api/ops/numpy#logicalor-function", 
    keras.ops.logspace = "https://keras.io/api/ops/numpy#logspace-function", 
    keras.ops.matmul = "https://keras.io/api/ops/numpy#matmul-function", 
    keras.ops.max = "https://keras.io/api/ops/numpy#max-function", 
    keras.ops.maximum = "https://keras.io/api/ops/numpy#maximum-function", 
    keras.ops.mean = "https://keras.io/api/ops/numpy#mean-function", 
    keras.ops.meshgrid = "https://keras.io/api/ops/numpy#meshgrid-function", 
    keras.ops.min = "https://keras.io/api/ops/numpy#min-function", 
    keras.ops.minimum = "https://keras.io/api/ops/numpy#minimum-function", 
    keras.ops.mod = "https://keras.io/api/ops/numpy#mod-function", 
    keras.ops.moveaxis = "https://keras.io/api/ops/numpy#moveaxis-function", 
    keras.ops.multiply = "https://keras.io/api/ops/numpy#multiply-function", 
    keras.ops.nan_to_num = "https://keras.io/api/ops/numpy#nantonum-function", 
    keras.ops.ndim = "https://keras.io/api/ops/numpy#ndim-function", 
    keras.ops.negative = "https://keras.io/api/ops/numpy#negative-function", 
    keras.ops.nonzero = "https://keras.io/api/ops/numpy#nonzero-function", 
    keras.ops.not_equal = "https://keras.io/api/ops/numpy#notequal-function", 
    keras.ops.ones = "https://keras.io/api/ops/numpy#ones-function", 
    keras.ops.ones_like = "https://keras.io/api/ops/numpy#oneslike-function", 
    keras.ops.outer = "https://keras.io/api/ops/numpy#outer-function", 
    keras.ops.pad = "https://keras.io/api/ops/numpy#pad-function", 
    keras.ops.power = "https://keras.io/api/ops/numpy#power-function", 
    keras.ops.prod = "https://keras.io/api/ops/numpy#prod-function", 
    keras.ops.ravel = "https://keras.io/api/ops/numpy#ravel-function", 
    keras.ops.real = "https://keras.io/api/ops/numpy#real-function", 
    keras.ops.reciprocal = "https://keras.io/api/ops/numpy#reciprocal-function", 
    keras.ops.repeat = "https://keras.io/api/ops/numpy#repeat-function", 
    keras.ops.reshape = "https://keras.io/api/ops/numpy#reshape-function", 
    keras.ops.roll = "https://keras.io/api/ops/numpy#roll-function", 
    keras.ops.round = "https://keras.io/api/ops/numpy#round-function", 
    keras.ops.sign = "https://keras.io/api/ops/numpy#sign-function", 
    keras.ops.sin = "https://keras.io/api/ops/numpy#sin-function", 
    keras.ops.sinh = "https://keras.io/api/ops/numpy#sinh-function", 
    keras.ops.size = "https://keras.io/api/ops/numpy#size-function", 
    keras.ops.sort = "https://keras.io/api/ops/numpy#sort-function", 
    keras.ops.split = "https://keras.io/api/ops/numpy#split-function", 
    keras.ops.sqrt = "https://keras.io/api/ops/numpy#sqrt-function", 
    keras.ops.square = "https://keras.io/api/ops/numpy#square-function", 
    keras.ops.squeeze = "https://keras.io/api/ops/numpy#squeeze-function", 
    keras.ops.stack = "https://keras.io/api/ops/numpy#stack-function", 
    keras.ops.std = "https://keras.io/api/ops/numpy#std-function", 
    keras.ops.subtract = "https://keras.io/api/ops/numpy#subtract-function", 
    keras.ops.sum = "https://keras.io/api/ops/numpy#sum-function", 
    keras.ops.swapaxes = "https://keras.io/api/ops/numpy#swapaxes-function", 
    keras.ops.take = "https://keras.io/api/ops/numpy#take-function", 
    keras.ops.take_along_axis = "https://keras.io/api/ops/numpy#takealongaxis-function", 
    keras.ops.tan = "https://keras.io/api/ops/numpy#tan-function", 
    keras.ops.tensordot = "https://keras.io/api/ops/numpy#tensordot-function", 
    keras.ops.tile = "https://keras.io/api/ops/numpy#tile-function", 
    keras.ops.trace = "https://keras.io/api/ops/numpy#trace-function", 
    keras.ops.transpose = "https://keras.io/api/ops/numpy#transpose-function", 
    keras.ops.tri = "https://keras.io/api/ops/numpy#tri-function", 
    keras.ops.tril = "https://keras.io/api/ops/numpy#tril-function", 
    keras.ops.triu = "https://keras.io/api/ops/numpy#triu-function", 
    keras.ops.true_divide = "https://keras.io/api/ops/numpy#truedivide-function", 
    keras.ops.var = "https://keras.io/api/ops/numpy#var-function", 
    keras.ops.vdot = "https://keras.io/api/ops/numpy#vdot-function", 
    keras.ops.vstack = "https://keras.io/api/ops/numpy#vstack-function", 
    keras.ops.where = "https://keras.io/api/ops/numpy#where-function", 
    keras.ops.zeros = "https://keras.io/api/ops/numpy#zeros-function", 
    keras.ops.zeros_like = "https://keras.io/api/ops/numpy#zeroslike-function", 
    keras.ops.average_pool = "https://keras.io/api/ops/nn#averagepool-function", 
    keras.ops.binary_crossentropy = "https://keras.io/api/ops/nn#binarycrossentropy-function", 
    keras.ops.categorical_crossentropy = "https://keras.io/api/ops/nn#categoricalcrossentropy-function", 
    keras.ops.conv = "https://keras.io/api/ops/nn#conv-function", 
    keras.ops.conv_transpose = "https://keras.io/api/ops/nn#convtranspose-function", 
    keras.ops.depthwise_conv = "https://keras.io/api/ops/nn#depthwiseconv-function", 
    keras.ops.elu = "https://keras.io/api/ops/nn#elu-function", 
    keras.ops.gelu = "https://keras.io/api/ops/nn#gelu-function", 
    keras.ops.hard_sigmoid = "https://keras.io/api/ops/nn#hardsigmoid-function", 
    keras.ops.leaky_relu = "https://keras.io/api/ops/nn#leakyrelu-function", 
    keras.ops.log_sigmoid = "https://keras.io/api/ops/nn#logsigmoid-function", 
    keras.ops.log_softmax = "https://keras.io/api/ops/nn#logsoftmax-function", 
    keras.ops.max_pool = "https://keras.io/api/ops/nn#maxpool-function", 
    keras.ops.one_hot = "https://keras.io/api/ops/nn#onehot-function", 
    keras.ops.relu = "https://keras.io/api/ops/nn#relu-function", 
    keras.ops.relu6 = "https://keras.io/api/ops/nn#relu6-function", 
    keras.ops.selu = "https://keras.io/api/ops/nn#selu-function", 
    keras.ops.separable_conv = "https://keras.io/api/ops/nn#separableconv-function", 
    keras.ops.sigmoid = "https://keras.io/api/ops/nn#sigmoid-function", 
    keras.ops.silu = "https://keras.io/api/ops/nn#silu-function", 
    keras.ops.softmax = "https://keras.io/api/ops/nn#softmax-function", 
    keras.ops.softplus = "https://keras.io/api/ops/nn#softplus-function", 
    keras.ops.softsign = "https://keras.io/api/ops/nn#softsign-function", 
    keras.ops.sparse_categorical_crossentropy = "https://keras.io/api/ops/nn#sparsecategoricalcrossentropy-function", 
    keras.ops.swish = "https://keras.io/api/ops/nn#swish-function", 
    keras.ops.tanh = "https://keras.io/api/ops/nn#tanh-function", 
    keras.ops.cast = "https://keras.io/api/ops/core#cast-function", 
    keras.ops.convert_to_numpy = "https://keras.io/api/ops/core#converttonumpy-function", 
    keras.ops.convert_to_tensor = "https://keras.io/api/ops/core#converttotensor-function", 
    keras.ops.extract_sequences = "https://keras.io/api/ops/core#extractsequences-function", 
    keras.ops.in_top_k = "https://keras.io/api/ops/core#intopk-function", 
    keras.ops.logsumexp = "https://keras.io/api/ops/core#logsumexp-function", 
    keras.ops.qr = "https://keras.io/api/ops/core#qr-function", 
    keras.ops.rsqrt = "https://keras.io/api/ops/core#rsqrt-function", 
    keras.ops.segment_max = "https://keras.io/api/ops/core#segmentmax-function", 
    keras.ops.scatter = "https://keras.io/api/ops/core#scatter-function", 
    keras.ops.scatter_update = "https://keras.io/api/ops/core#scatterupdate-function", 
    keras.ops.segment_sum = "https://keras.io/api/ops/core#segmentsum-function", 
    keras.ops.shape = "https://keras.io/api/ops/core#shape-function", 
    keras.ops.slice = "https://keras.io/api/ops/core#slice-function", 
    keras.ops.slice_update = "https://keras.io/api/ops/core#sliceupdate-function", 
    keras.ops.stop_gradient = "https://keras.io/api/ops/core#stopgradient-function", 
    keras.ops.top_k = "https://keras.io/api/ops/core#topk-function", 
    keras.ops.while_loop = "https://keras.io/api/ops/core#whileloop-function", 
    keras.ops.image.resize = "https://keras.io/api/ops/image#resize-function", 
    keras.ops.image.affine_transform = "https://keras.io/api/ops/image#affinetransform-function", 
    keras.ops.image.extract_patches = "https://keras.io/api/ops/image#extractpatches-function", 
    keras.ops.fft = "https://keras.io/api/ops/fft#fft-function", 
    keras.ops.fft2 = "https://keras.io/api/ops/fft#fft2-function", 
    keras.ops.rfft = "https://keras.io/api/ops/fft#rfft-function", 
    keras.ops.stft = "https://keras.io/api/ops/fft#stft-function", 
    keras.ops.irfft = "https://keras.io/api/ops/fft#irfft-function", 
    keras.ops.istft = "https://keras.io/api/ops/fft#istft-function", 
    keras.optimizers.Optimizer.apply_gradients = "https://keras.io/api/optimizers#applygradients-method", 
    keras.optimizers.Optimizer.variables = "https://keras.io/api/optimizers#variables-property", 
    keras.optimizers.SGD = "https://keras.io/api/optimizers/sgd#sgd-class", 
    keras.optimizers.RMSprop = "https://keras.io/api/optimizers/rmsprop#rmsprop-class", 
    keras.optimizers.Adam = "https://keras.io/api/optimizers/adam#adam-class", 
    keras.optimizers.AdamW = "https://keras.io/api/optimizers/adamw#adamw-class", 
    keras.optimizers.Adadelta = "https://keras.io/api/optimizers/adadelta#adadelta-class", 
    keras.optimizers.Adagrad = "https://keras.io/api/optimizers/adagrad#adagrad-class", 
    keras.optimizers.Adamax = "https://keras.io/api/optimizers/adamax#adamax-class", 
    keras.optimizers.Adafactor = "https://keras.io/api/optimizers/adafactor#adafactor-class", 
    keras.optimizers.Nadam = "https://keras.io/api/optimizers/Nadam#nadam-class", 
    keras.optimizers.Ftrl = "https://keras.io/api/optimizers/ftrl#ftrl-class", 
    keras.optimizers.schedules.ExponentialDecay = "https://keras.io/api/optimizers/learning_rate_schedules/exponential_decay#exponentialdecay-class", 
    keras.optimizers.schedules.PiecewiseConstantDecay = "https://keras.io/api/optimizers/learning_rate_schedules/piecewise_constant_decay#piecewiseconstantdecay-class", 
    keras.optimizers.schedules.PolynomialDecay = "https://keras.io/api/optimizers/learning_rate_schedules/polynomial_decay#polynomialdecay-class", 
    keras.optimizers.schedules.InverseTimeDecay = "https://keras.io/api/optimizers/learning_rate_schedules/inverse_time_decay#inversetimedecay-class", 
    keras.optimizers.schedules.CosineDecay = "https://keras.io/api/optimizers/learning_rate_schedules/cosine_decay#cosinedecay-class", 
    keras.optimizers.schedules.CosineDecayRestarts = "https://keras.io/api/optimizers/learning_rate_schedules/cosine_decay_restarts#cosinedecayrestarts-class", 
    keras.metrics.Accuracy = "https://keras.io/api/metrics/accuracy_metrics#accuracy-class", 
    keras.metrics.BinaryAccuracy = "https://keras.io/api/metrics/accuracy_metrics#binaryaccuracy-class", 
    keras.metrics.CategoricalAccuracy = "https://keras.io/api/metrics/accuracy_metrics#categoricalaccuracy-class", 
    keras.metrics.SparseCategoricalAccuracy = "https://keras.io/api/metrics/accuracy_metrics#sparsecategoricalaccuracy-class", 
    keras.metrics.TopKCategoricalAccuracy = "https://keras.io/api/metrics/accuracy_metrics#topkcategoricalaccuracy-class", 
    keras.metrics.SparseTopKCategoricalAccuracy = "https://keras.io/api/metrics/accuracy_metrics#sparsetopkcategoricalaccuracy-class", 
    keras.metrics.BinaryCrossentropy = "https://keras.io/api/metrics/probabilistic_metrics#binarycrossentropy-class", 
    keras.metrics.CategoricalCrossentropy = "https://keras.io/api/metrics/probabilistic_metrics#categoricalcrossentropy-class", 
    keras.metrics.SparseCategoricalCrossentropy = "https://keras.io/api/metrics/probabilistic_metrics#sparsecategoricalcrossentropy-class", 
    keras.metrics.KLDivergence = "https://keras.io/api/metrics/probabilistic_metrics#kldivergence-class", 
    keras.metrics.Poisson = "https://keras.io/api/metrics/probabilistic_metrics#poisson-class", 
    keras.metrics.MeanSquaredError = "https://keras.io/api/metrics/regression_metrics#meansquarederror-class", 
    keras.metrics.RootMeanSquaredError = "https://keras.io/api/metrics/regression_metrics#rootmeansquarederror-class", 
    keras.metrics.MeanAbsoluteError = "https://keras.io/api/metrics/regression_metrics#meanabsoluteerror-class", 
    keras.metrics.MeanAbsolutePercentageError = "https://keras.io/api/metrics/regression_metrics#meanabsolutepercentageerror-class", 
    keras.metrics.MeanSquaredLogarithmicError = "https://keras.io/api/metrics/regression_metrics#meansquaredlogarithmicerror-class", 
    keras.metrics.CosineSimilarity = "https://keras.io/api/metrics/regression_metrics#cosinesimilarity-class", 
    keras.metrics.LogCoshError = "https://keras.io/api/metrics/regression_metrics#logcosherror-class", 
    keras.metrics.AUC = "https://keras.io/api/metrics/classification_metrics#auc-class", 
    keras.metrics.Precision = "https://keras.io/api/metrics/classification_metrics#precision-class", 
    keras.metrics.Recall = "https://keras.io/api/metrics/classification_metrics#recall-class", 
    keras.metrics.TruePositives = "https://keras.io/api/metrics/classification_metrics#truepositives-class", 
    keras.metrics.TrueNegatives = "https://keras.io/api/metrics/classification_metrics#truenegatives-class", 
    keras.metrics.FalsePositives = "https://keras.io/api/metrics/classification_metrics#falsepositives-class", 
    keras.metrics.FalseNegatives = "https://keras.io/api/metrics/classification_metrics#falsenegatives-class", 
    keras.metrics.PrecisionAtRecall = "https://keras.io/api/metrics/classification_metrics#precisionatrecall-class", 
    keras.metrics.SensitivityAtSpecificity = "https://keras.io/api/metrics/classification_metrics#sensitivityatspecificity-class", 
    keras.metrics.SpecificityAtSensitivity = "https://keras.io/api/metrics/classification_metrics#specificityatsensitivity-class", 
    keras.metrics.MeanIoU = "https://keras.io/api/metrics/segmentation_metrics#meaniou-class", 
    keras.metrics.Hinge = "https://keras.io/api/metrics/hinge_metrics#hinge-class", 
    keras.metrics.SquaredHinge = "https://keras.io/api/metrics/hinge_metrics#squaredhinge-class", 
    keras.metrics.CategoricalHinge = "https://keras.io/api/metrics/hinge_metrics#categoricalhinge-class", 
    keras.losses.BinaryCrossentropy = "https://keras.io/api/losses/probabilistic_losses#binarycrossentropy-class", 
    keras.losses.CategoricalCrossentropy = "https://keras.io/api/losses/probabilistic_losses#categoricalcrossentropy-class", 
    keras.losses.SparseCategoricalCrossentropy = "https://keras.io/api/losses/probabilistic_losses#sparsecategoricalcrossentropy-class", 
    keras.losses.Poisson = "https://keras.io/api/losses/probabilistic_losses#poisson-class", 
    keras.losses.binary_crossentropy = "https://keras.io/api/losses/probabilistic_losses#binarycrossentropy-function", 
    keras.losses.categorical_crossentropy = "https://keras.io/api/losses/probabilistic_losses#categoricalcrossentropy-function", 
    keras.losses.sparse_categorical_crossentropy = "https://keras.io/api/losses/probabilistic_losses#sparsecategoricalcrossentropy-function", 
    keras.losses.poisson = "https://keras.io/api/losses/probabilistic_losses#poisson-function", 
    keras.losses.KLDivergence = "https://keras.io/api/losses/probabilistic_losses#kldivergence-class", 
    keras.losses.kl_divergence = "https://keras.io/api/losses/probabilistic_losses#kldivergence-function", 
    keras.losses.MeanSquaredError = "https://keras.io/api/losses/regression_losses#meansquarederror-class", 
    keras.losses.MeanAbsoluteError = "https://keras.io/api/losses/regression_losses#meanabsoluteerror-class", 
    keras.losses.MeanAbsolutePercentageError = "https://keras.io/api/losses/regression_losses#meanabsolutepercentageerror-class", 
    keras.losses.MeanSquaredLogarithmicError = "https://keras.io/api/losses/regression_losses#meansquaredlogarithmicerror-class", 
    keras.losses.CosineSimilarity = "https://keras.io/api/losses/regression_losses#cosinesimilarity-class", 
    keras.losses.mean_squared_error = "https://keras.io/api/losses/regression_losses#meansquarederror-function", 
    keras.losses.mean_absolute_error = "https://keras.io/api/losses/regression_losses#meanabsoluteerror-function", 
    keras.losses.mean_absolute_percentage_error = "https://keras.io/api/losses/regression_losses#meanabsolutepercentageerror-function", 
    keras.losses.mean_squared_logarithmic_error = "https://keras.io/api/losses/regression_losses#meansquaredlogarithmicerror-function", 
    keras.losses.cosine_similarity = "https://keras.io/api/losses/regression_losses#cosinesimilarity-function", 
    keras.losses.Huber = "https://keras.io/api/losses/regression_losses#huber-class", 
    keras.losses.huber = "https://keras.io/api/losses/regression_losses#huber-function", 
    keras.losses.LogCosh = "https://keras.io/api/losses/regression_losses#logcosh-class", 
    keras.losses.log_cosh = "https://keras.io/api/losses/regression_losses#logcosh-function", 
    keras.losses.Hinge = "https://keras.io/api/losses/hinge_losses#hinge-class", 
    keras.losses.SquaredHinge = "https://keras.io/api/losses/hinge_losses#squaredhinge-class", 
    keras.losses.CategoricalHinge = "https://keras.io/api/losses/hinge_losses#categoricalhinge-class", 
    keras.losses.hinge = "https://keras.io/api/losses/hinge_losses#hinge-function", 
    keras.losses.squared_hinge = "https://keras.io/api/losses/hinge_losses#squaredhinge-function", 
    keras.losses.categorical_hinge = "https://keras.io/api/losses/hinge_losses#categoricalhinge-function", 
    keras.utils.image_dataset_from_directory = "https://keras.io/api/data_loading/image#imagedatasetfromdirectory-function", 
    keras.utils.load_img = "https://keras.io/api/data_loading/image#loadimg-function", 
    keras.utils.img_to_array = "https://keras.io/api/data_loading/image#imgtoarray-function", 
    keras.utils.save_img = "https://keras.io/api/data_loading/image#saveimg-function", 
    keras.utils.timeseries_dataset_from_array = "https://keras.io/api/data_loading/timeseries#timeseriesdatasetfromarray-function", 
    keras.utils.pad_sequences = "https://keras.io/api/data_loading/timeseries#padsequences-function", 
    keras.utils.text_dataset_from_directory = "https://keras.io/api/data_loading/text#textdatasetfromdirectory-function", 
    keras.utils.audio_dataset_from_directory = "https://keras.io/api/data_loading/audio#audiodatasetfromdirectory-function", 
    keras.datasets.mnist.load_data = "https://keras.io/api/datasets/mnist#loaddata-function", 
    keras.datasets.cifar10.load_data = "https://keras.io/api/datasets/cifar10#loaddata-function", 
    keras.datasets.cifar100.load_data = "https://keras.io/api/datasets/cifar100#loaddata-function", 
    keras.datasets.imdb.load_data = "https://keras.io/api/datasets/imdb#loaddata-function", 
    keras.datasets.imdb.get_word_index = "https://keras.io/api/datasets/imdb#getwordindex-function", 
    keras.datasets.reuters.load_data = "https://keras.io/api/datasets/reuters#loaddata-function", 
    keras.datasets.reuters.get_word_index = "https://keras.io/api/datasets/reuters#getwordindex-function", 
    keras.datasets.fashion_mnist.load_data = "https://keras.io/api/datasets/fashion_mnist#loaddata-function", 
    keras.datasets.boston_housing.load_data = "https://keras.io/api/datasets/boston_housing#loaddata-function", 
    keras.applications.Xception = "https://keras.io/api/applications/xception#xception-function", 
    keras.applications.EfficientNetB0 = "https://keras.io/api/applications/efficientnet#efficientnetb0-function", 
    keras.applications.EfficientNetB1 = "https://keras.io/api/applications/efficientnet#efficientnetb1-function", 
    keras.applications.EfficientNetB2 = "https://keras.io/api/applications/efficientnet#efficientnetb2-function", 
    keras.applications.EfficientNetB3 = "https://keras.io/api/applications/efficientnet#efficientnetb3-function", 
    keras.applications.EfficientNetB4 = "https://keras.io/api/applications/efficientnet#efficientnetb4-function", 
    keras.applications.EfficientNetB5 = "https://keras.io/api/applications/efficientnet#efficientnetb5-function", 
    keras.applications.EfficientNetB6 = "https://keras.io/api/applications/efficientnet#efficientnetb6-function", 
    keras.applications.EfficientNetB7 = "https://keras.io/api/applications/efficientnet#efficientnetb7-function", 
    keras.applications.EfficientNetV2B0 = "https://keras.io/api/applications/efficientnet_v2#efficientnetv2b0-function", 
    keras.applications.EfficientNetV2B1 = "https://keras.io/api/applications/efficientnet_v2#efficientnetv2b1-function", 
    keras.applications.EfficientNetV2B2 = "https://keras.io/api/applications/efficientnet_v2#efficientnetv2b2-function", 
    keras.applications.EfficientNetV2B3 = "https://keras.io/api/applications/efficientnet_v2#efficientnetv2b3-function", 
    keras.applications.EfficientNetV2S = "https://keras.io/api/applications/efficientnet_v2#efficientnetv2s-function", 
    keras.applications.EfficientNetV2M = "https://keras.io/api/applications/efficientnet_v2#efficientnetv2m-function", 
    keras.applications.EfficientNetV2L = "https://keras.io/api/applications/efficientnet_v2#efficientnetv2l-function", 
    keras.applications.ConvNeXtTiny = "https://keras.io/api/applications/convnext#convnexttiny-function", 
    keras.applications.ConvNeXtSmall = "https://keras.io/api/applications/convnext#convnextsmall-function", 
    keras.applications.ConvNeXtBase = "https://keras.io/api/applications/convnext#convnextbase-function", 
    keras.applications.ConvNeXtLarge = "https://keras.io/api/applications/convnext#convnextlarge-function", 
    keras.applications.ConvNeXtXLarge = "https://keras.io/api/applications/convnext#convnextxlarge-function", 
    keras.applications.VGG16 = "https://keras.io/api/applications/vgg#vgg16-function", 
    keras.applications.VGG19 = "https://keras.io/api/applications/vgg#vgg19-function", 
    keras.applications.ResNet50 = "https://keras.io/api/applications/resnet#resnet50-function", 
    keras.applications.ResNet101 = "https://keras.io/api/applications/resnet#resnet101-function", 
    keras.applications.ResNet152 = "https://keras.io/api/applications/resnet#resnet152-function", 
    keras.applications.ResNet50V2 = "https://keras.io/api/applications/resnet#resnet50v2-function", 
    keras.applications.ResNet101V2 = "https://keras.io/api/applications/resnet#resnet101v2-function", 
    keras.applications.ResNet152V2 = "https://keras.io/api/applications/resnet#resnet152v2-function", 
    keras.applications.MobileNet = "https://keras.io/api/applications/mobilenet#mobilenet-function", 
    keras.applications.MobileNetV2 = "https://keras.io/api/applications/mobilenet#mobilenetv2-function", 
    keras.applications.MobileNetV3Small = "https://keras.io/api/applications/mobilenet#mobilenetv3small-function", 
    keras.applications.MobileNetV3Large = "https://keras.io/api/applications/mobilenet#mobilenetv3large-function", 
    keras.applications.DenseNet121 = "https://keras.io/api/applications/densenet#densenet121-function", 
    keras.applications.DenseNet169 = "https://keras.io/api/applications/densenet#densenet169-function", 
    keras.applications.DenseNet201 = "https://keras.io/api/applications/densenet#densenet201-function", 
    keras.applications.NASNetLarge = "https://keras.io/api/applications/nasnet#nasnetlarge-function", 
    keras.applications.NASNetMobile = "https://keras.io/api/applications/nasnet#nasnetmobile-function", 
    keras.applications.InceptionV3 = "https://keras.io/api/applications/inceptionv3#inceptionv3-function", 
    keras.applications.InceptionResNetV2 = "https://keras.io/api/applications/inceptionresnetv2#inceptionresnetv2-function", 
    keras.mixed_precision.DTypePolicy = "https://keras.io/api/mixed_precision/policy#dtypepolicy-class", 
    keras.mixed_precision.dtype_policy = "https://keras.io/api/mixed_precision/policy#dtypepolicy-function", 
    keras.mixed_precision.set_dtype_policy = "https://keras.io/api/mixed_precision/policy#setdtypepolicy-function", 
    keras.utils.plot_model = "https://keras.io/api/utils/model_plotting_utils#plotmodel-function", 
    keras.utils.model_to_dot = "https://keras.io/api/utils/model_plotting_utils#modeltodot-function", 
    keras.utils.FeatureSpace = "https://keras.io/api/utils/feature_space#featurespace-class", 
    keras.utils.set_random_seed = "https://keras.io/api/utils/python_utils#setrandomseed-function", 
    keras.utils.split_dataset = "https://keras.io/api/utils/python_utils#splitdataset-function", 
    keras.utils.get_file = "https://keras.io/api/utils/python_utils#getfile-function", 
    keras.utils.Progbar = "https://keras.io/api/utils/python_utils#progbar-class", 
    keras.utils.PyDataset = "https://keras.io/api/utils/python_utils#pydataset-class", 
    keras.utils.to_categorical = "https://keras.io/api/utils/python_utils#tocategorical-function", 
    keras.utils.normalize = "https://keras.io/api/utils/python_utils#normalize-function", 
    keras.utils.clear_session = "https://keras.io/api/utils/config_utils#clearsession-function", 
    keras.config.floatx = "https://keras.io/api/utils/config_utils#floatx-function", 
    keras.config.set_floatx = "https://keras.io/api/utils/config_utils#setfloatx-function", 
    keras.config.image_data_format = "https://keras.io/api/utils/config_utils#imagedataformat-function", 
    keras.config.set_image_data_format = "https://keras.io/api/utils/config_utils#setimagedataformat-function", 
    keras.config.epsilon = "https://keras.io/api/utils/config_utils#epsilon-function", 
    keras.config.set_epsilon = "https://keras.io/api/utils/config_utils#setepsilon-function")
